#!/bin/sh

#===================================================================================================
# get_refresh_token.sh
#
# Simba Technologies Inc.
# Copyright (C) 2013 Simba Technologies Incorporated
#
# Given an input Authentication Token for Google BigQuery, generate a RefreshToken which can be
# used in the RefreshToken key in the driver.
#
# This script requires the curl executable to be in the user's PATH.
#
# The Authentication Token can be generated by going to the URL:
# https://accounts.google.com/o/oauth2/auth?scope=https://www.googleapis.com/auth/bigquery&response_type=code&redirect_uri=urn:ietf:wg:oauth:2.0:oob&client_id=977385342095.apps.googleusercontent.com&hl=en&from_login=1&as=76356ac9e8ce640b&pli=1&authuser=0
# Note that an Authentication Token can only be used once and can expire over time.
# You can refresh the page to generate a new one.
#
# Arguments:
# 1. The Authentication Token
#===================================================================================================

if [ $# -eq 0 ]
then
    echo "Usage `basename $0` \"<Authentication Token>\""
    exit -1
fi

refreshToken=`curl -X POST -d "code=$1&client_id=977385342095.apps.googleusercontent.com&client_secret=wbER7576mc_1YOII0dGk7jEE&redirect_uri=urn:ietf:wg:oauth:2.0:oob&grant_type=authorization_code" --header "Content-type=application/x-www-form-urlencoded" https://accounts.google.com/o/oauth2/token -v 2>/dev/null |  grep "refresh_token" | sed -e 's/"//g'`

if [ -n "$refreshToken" ]
then
    echo $refreshToken
    exit 0
else
    echo "Refresh Token could not be generated. Please verify that the authentication token was copied directly. It may be necessary to wrap it in quotes."
    exit -1
fi
